package light;
import interfaces.IRepresentation;

import java.util.Vector;


public class RobotController {
	
	protected Robot robot;
	private IRepresentation network;
	
	private Vector<Float> input = new Vector<Float>();
	private Vector<Float> output = new Vector<Float>();
	
	double[] sensorvalues;

	public RobotController (IRepresentation rep, Light parent) {
		this.network = rep;
		rep.reset();
		//this.parent = parent;
	}
	
	/** Sets the controller to the pre-info stage (before receiving sensor data) */
	public void preInfo() {
		//reset values here if necessary
		sensorvalues = new double[]{0,0};
	}
	
	/** The behavior of the drone */
	public void postInfo() {
		input.clear();
		//add sensor values here
		input.add((float)(1-sensorvalues[0]/Robot.LIGHT_SENSOR_RANGE) );
		input.add((float)(1-sensorvalues[1]/Robot.LIGHT_SENSOR_RANGE));		
		//calculate network output
		output = network.getOutput(input);
		//use output for control
		this.robot.setSpeed(output.get(0),output.get(1));
		//this.robot.setSpeed(1,1);
	}
	
	public void setRobot(Robot r) {
		this.robot = r;
	}
	
	public void setSensorValues(double[] svalues) {
		sensorvalues = svalues;
	}
}
