package fulltournament;
/*
 * Copyright (C) 2009 Istvan Fehervari, Wilfried Elmenreich
 * Original project page: http://www.frevotool.tk
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License Version 3 as published
 * by the Free Software Foundation http://www.gnu.org/licenses/gpl-3.0.txt
 *
 * There is no warranty for this free software. The GPL requires that 
 * modified versions be marked as changed, so that their problems will
 * not be attributed erroneously to authors of previous versions.
 */
import interfaces.ComponentXMLdata;
import interfaces.IMethod;
import interfaces.IProblem;
import interfaces.IRanking;
import interfaces.IRepresentation;

import java.util.ArrayList;
import java.util.Collections;


public class FullTournament extends IRanking {

	@Override
	public void rank(ArrayList<IRepresentation> pop, ComponentXMLdata problem, IMethod method) {
		ArrayList<IRepresentation> result = new ArrayList<IRepresentation>();
		ArrayList<Resultrecord> results = new ArrayList<Resultrecord>();
		
		for (int i=0; i< pop.size();i++) {
			results.add(new Resultrecord(i));
		}
		
		//Create scores
		for (int k=0;k<pop.size()-1;k++) {
			IRepresentation p1 = pop.get(k);
			for (int j = k+1;j<pop.size()-1-k;j++) {
				//play game
				IRepresentation p2 = pop.get(j);
				try {
					IProblem p = (IProblem)(problem.prepareComponent());
					int gameres = (int)p.getResult(new IRepresentation[]{p1,p2});
					if (gameres == 1) {
						results.get(k).add(2);
					}
					else if (gameres == -1) {
						results.get(j).add(2);
					}
					else if (gameres == 0) {
						results.get(k).add(1);
						results.get(j).add(1);
					}
					
				} catch (InstantiationException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				}
			}
		}
		
		Collections.sort(results,Collections.reverseOrder());
		
		for (int s=0;s<pop.size();s++) {
			result.add( pop.get(results.get(0).number) );
		}
		
		//copy result back into pop
		for (int u=0; u<pop.size();u++) {
			pop.set(u, result.get(u));
		}
		//pop = result;
				
	}
	
	private class Resultrecord implements Comparable<Resultrecord>{
		public int number;
		public int score = 0;
		
		public Resultrecord(int number) {
			this.number = number;
		}
		
		public void add(int point) {
			score = score+point;
		}

		@Override
		public int compareTo(Resultrecord other) {
			if (this.score > other.score) return 1;
			else if (this.score < other.score) return -1;
			else return 0;
		}
	}

}
