package swissSystem;
/*
 * Copyright (C) 2009 Istvan Fehervari, Wilfried Elmenreich
 * Original project page: http://www.frevotool.tk
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License Version 3 as published
 * by the Free Software Foundation http://www.gnu.org/licenses/gpl-3.0.txt
 *
 * There is no warranty for this free software. The GPL requires that 
 * modified versions be marked as changed, so that their problems will
 * not be attributed erroneously to authors of previous versions.
 */
public class ResultElement {

	private int id;
	private int result;
	private int hashcode;
	
	public ResultElement (int id, int result) {
		this.id = id;
		this.result = result;
	}
	
	public ResultElement (int id, int result, int hc) {
		this(id,result);
		hashcode = hc;
	}
	
	public int getId() {
		return id;
	}
	
	public int getHashcode() {
		return hashcode;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public int getResult() {
		return this.result;
	}
	
	public void setResult(int result) {
		this.result = result;
	}
	
	/**
	 * Return true if the game against this id was won, false otherwise
	 * @return
	 */
	public boolean isWin() {
		if (result == 1) return true;
		else return false;
	}
}
