/*
 * Copyright (C) 2009 Istvan Fehervari, Wilfried Elmenreich
 * Original project page: http://www.frevotool.tk
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License Version 3 as published
 * by the Free Software Foundation http://www.gnu.org/licenses/gpl-3.0.txt
 *
 * There is no warranty for this free software. The GPL requires that 
 * modified versions be marked as changed, so that their problems will
 * not be attributed erroneously to authors of previous versions.
 */
package interfaces;

/** Class serving as a container for custom file export functions in components */
public class FileType {
	
	/** The file extension like "exe" or "txt */
	private String extension;
	
	/** A short description to display in save/load dialog boxes */
	private String description;

	public FileType(String extension, String description) {
		this.extension = extension;
		this.description = description;
	}

	/**
	 * @return the extension of the file type
	 */
	public String getExtension() {
		return extension;
	}

	/**
	 * @param extension the extension to set for this file type
	 */
	public void setExtension(String extension) {
		this.extension = extension;
	}

	/**
	 * @return the short description of this file 
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description a short description to set for save/load dialog boxes
	 */
	public void setDescription(String description) {
		this.description = description;
	}
}
